import shutil

from typing import (overload, Optional, Literal,)

@overload
def shutil_which(
    name: str,
    raise_on_failure: Literal[True],
) -> str: ...

@overload
def shutil_which(
    name: str,
    raise_on_failure: bool,
) -> Optional[str]: ...

def shutil_which(
    name: str,
    raise_on_failure: bool,
) -> Optional[str]:
    res = shutil.which(name)
    if res is None and raise_on_failure:
        raise NotImplementedError
    else:
        return res